from multiprocessing import Process
from multiprocessing.managers import SharedMemoryManager
import math, time


def compute_function(thread_index, sl):
  sum = 0
  for i in range(0,10000):
    for j in range(0,5000):
      sum += math.cos(i) * math.sin(j)
  sl[thread_index] = thread_index

def run_threads(sl, num_threads):

  print(f"Starting {num_threads} threads...", end='', flush=True)
  begin = time.time()
  procs = []
  for thread_index in range(0, num_threads): 
    proc = Process(target=compute_function, args=(thread_index, sl))
    procs.append(proc)
    proc.start()

  for proc in procs:
    proc.join()
  end = time.time()
  print(f"done in {(end - begin):.2f} seconds")
  print(list(sl))
  for i in range(0, len(sl)):
    sl[i] = -1


if __name__ == "__main__": 
  smm = SharedMemoryManager()
  smm.start()
  sl = smm.ShareableList([-1] * 4)
  print(list(sl))

  run_threads(sl, 1)
  run_threads(sl, 2)
  run_threads(sl, 4)
  smm.shutdown()
